﻿Imports System
Imports System.Collections.Generic
Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports BackupOnBuild

'''<summary>
'''This is a test class for BusinessTest and is intended
'''to contain all BusinessTest Unit Tests
'''</summary>
<TestClass()> _
Public Class BusinessTest


    Private testContextInstance As TestContext

    '''<summary>
    '''Gets or sets the test context which provides
    '''information about and functionality for the current test run.
    '''</summary>
    Public Property TestContext() As TestContext
        Get
            Return testContextInstance
        End Get
        Set(ByVal value As TestContext)
            testContextInstance = Value
        End Set
    End Property

#Region "Additional test attributes"
    '
    'You can use the following additional attributes as you write your tests:
    '
    'Use ClassInitialize to run code before running the first test in the class
    '<ClassInitialize()>  _
    'Public Shared Sub MyClassInitialize(ByVal testContext As TestContext)
    'End Sub
    '
    'Use ClassCleanup to run code after all tests in a class have run
    '<ClassCleanup()>  _
    'Public Shared Sub MyClassCleanup()
    'End Sub
    '
    'Use TestInitialize to run code before running each test
    '<TestInitialize()>  _
    'Public Sub MyTestInitialize()
    'End Sub
    '
    'Use TestCleanup to run code after each test has run
    '<TestCleanup()>  _
    'Public Sub MyTestCleanup()
    'End Sub
    '
#End Region


    '''<summary>
    '''A test for Business Constructor
    '''</summary>
    <TestMethod()> _
    Public Sub BusinessConstructorTest()
        Dim target As Business = New Business()
        Assert.IsInstanceOfType(target, GetType(Business))
    End Sub

    '''<summary>
    '''A test for Backup
    '''</summary>
    <TestMethod()> _
    Public Sub BackupTest()
        'Dim SourceFolder As String = String.Empty ' TODO: Initialize to an appropriate value
        'Dim BackupFolder As String = String.Empty ' TODO: Initialize to an appropriate value
        'Dim FullBackupDue As Boolean = False ' TODO: Initialize to an appropriate value
        'Dim Extensions As String = String.Empty ' TODO: Initialize to an appropriate value
        'Dim TextLog As Boolean = False ' TODO: Initialize to an appropriate value
        'Dim CompressBackup As Boolean = False ' TODO: Initialize to an appropriate value
        'Dim SkippedExtensionsReport As Boolean = False ' TODO: Initialize to an appropriate value
        'Dim SkippedExtensions As List(Of String) = Nothing ' TODO: Initialize to an appropriate value
        'Dim SkippedExtensionsExpected As List(Of String) = Nothing ' TODO: Initialize to an appropriate value
        'Dim expected As Boolean = False ' TODO: Initialize to an appropriate value
        'Dim actual As Boolean
        'actual = Business.Backup(SourceFolder, BackupFolder, FullBackupDue, Extensions, TextLog, CompressBackup, SkippedExtensionsReport, SkippedExtensions)
        'Assert.AreEqual(SkippedExtensionsExpected, SkippedExtensions)
        'Assert.AreEqual(expected, actual)
        Assert.Inconclusive("Verify the correctness of this test method.")
    End Sub

    '''<summary>
    '''A test for DeleteBackupFolderToRecyleBin
    '''</summary>
    <TestMethod()> _
    Public Sub DeleteBackupFolderToRecyleBinTest()
        'Dim FolderPathToDelete As String = String.Empty ' TODO: Initialize to an appropriate value
        'Business.DeleteBackupFolderToRecyleBin(FolderPathToDelete)
        Assert.Inconclusive("A method that does not return a value cannot be verified.")
    End Sub

    '''<summary>
    '''A test for FileFriendlyDateTime
    '''</summary>
    <TestMethod()> _
    Public Sub FileFriendlyDateTimeTest()
        Dim dt As DateTime = DateTime.Parse("01-01-2010 01:23 am")
        Dim expected As String = ""
        Dim actual As String = Business.FileFriendlyDateTime(dt)
        Assert.AreEqual(expected, actual)
    End Sub

    '''<summary>
    '''A test for FolderBackup
    '''</summary>
    <TestMethod()> _
    Public Sub FolderBackupTest()
        'Dim FullPathSourceFolder As String = String.Empty ' TODO: Initialize to an appropriate value
        'Dim FullPathBackupFolder As String = String.Empty ' TODO: Initialize to an appropriate value
        'Dim FullBackup As Boolean = False ' TODO: Initialize to an appropriate value
        'Dim Extensions As String = String.Empty ' TODO: Initialize to an appropriate value
        'Dim TextLog As Boolean = False ' TODO: Initialize to an appropriate value
        'Dim SkippedExtensionsReport As Boolean = False ' TODO: Initialize to an appropriate value
        'Dim SkippedExtensions As List(Of String) = Nothing ' TODO: Initialize to an appropriate value
        'Dim SkippedExtensionsExpected As List(Of String) = Nothing ' TODO: Initialize to an appropriate value
        'Business.FolderBackup(FullPathSourceFolder, FullPathBackupFolder, FullBackup, Extensions, TextLog, SkippedExtensionsReport, SkippedExtensions)
        'Assert.AreEqual(SkippedExtensionsExpected, SkippedExtensions)
        Assert.Inconclusive("A method that does not return a value cannot be verified.")
    End Sub

    '''<summary>
    '''A test for GetLastFullBackupDate
    '''</summary>
    <TestMethod()> _
    Public Sub GetLastFullBackupDateTest()
        'Dim BackupFolder As String = String.Empty ' TODO: Initialize to an appropriate value
        'Dim expected As DateTime = New DateTime() ' TODO: Initialize to an appropriate value
        'Dim actual As DateTime
        'actual = Business.GetLastFullBackupDate(BackupFolder)
        'Assert.AreEqual(expected, actual)
        Assert.Inconclusive("Verify the correctness of this test method.")
    End Sub

    '''<summary>
    '''A test for IsFullBackupDue for the ALWAYS value
    '''</summary>
    <TestMethod()> _
    Public Sub IsFullBackupDueTest_Always()
        'Possible Values:   Always, Never, Monthly, BiWeekly, Weekly, Daily, Hourly, 
        '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
        Dim LastFullBackup As DateTime = DateTime.Parse("12-31-2009")
        Dim actual As Boolean = Business.IsFullBackupDue(LastFullBackup, Now, "Always")
        Assert.IsTrue(actual)
    End Sub

    '''<summary>
    '''A test for IsFullBackupDue for the NEVER value
    '''</summary>
    <TestMethod()> _
    Public Sub IsFullBackupDueTest_Never()
        'Possible Values:   Always, Never, Monthly, BiWeekly, Weekly, Daily, Hourly, 
        '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
        Dim LastFullBackup As DateTime = DateTime.Parse("12-31-2009")
        Dim actual As Boolean = Business.IsFullBackupDue(LastFullBackup, Now, "Never")
        Assert.IsFalse(actual)
    End Sub

    '''<summary>
    '''A test for IsFullBackupDue for the MONTHLY value
    '''</summary>
    <TestMethod()> _
    Public Sub IsFullBackupDueTest_Monthly()
        'Possible Values:   Always, Never, Monthly, BiWeekly, Weekly, Daily, Hourly, 
        '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
        Dim LastFullBackup As DateTime = DateTime.Parse("12-31-2009")
        Dim AsOfDate As DateTime = DateTime.Parse("01-01-2010")
        Dim actual As Boolean = Business.IsFullBackupDue(LastFullBackup, AsOfDate, "Monthly")
        Assert.IsTrue(actual)

        LastFullBackup = DateTime.Parse("12-15-2009")
        AsOfDate = DateTime.Parse("12-31-2009")
        actual = Business.IsFullBackupDue(LastFullBackup, AsOfDate, "Monthly")
        Assert.IsFalse(actual)

        LastFullBackup = DateTime.Parse("12-15-2009")
        AsOfDate = DateTime.Parse("02-15-2010")
        actual = Business.IsFullBackupDue(LastFullBackup, AsOfDate, "Monthly")
        Assert.IsTrue(actual)

    End Sub

    '''<summary>
    '''A test for IsFullBackupDue for the BiWeekly value
    '''</summary>
    <TestMethod()> _
    Public Sub IsFullBackupDueTest_BiWeekly()
        'Possible Values:   Always, Never, Monthly, BiWeekly, Weekly, Daily, Hourly, 
        '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
        'Dim LastFullBackup As DateTime = DateTime.Parse("12-31-2009")
        'Dim AsOfDate As DateTime = DateTime.Parse("01-01-2010")
        'Dim actual As Boolean = Business.IsFullBackupDue(LastFullBackup, AsOfDate, "BiWeekly")
        Assert.Inconclusive("A method that does not return a value cannot be verified.")
    End Sub

    '''<summary>
    '''A test for IsFullBackupDue for the Weekly value
    '''</summary>
    <TestMethod()> _
    Public Sub IsFullBackupDueTest_Weekly()
        'Possible Values:   Always, Never, Monthly, Weekly, Weekly, Daily, Hourly, 
        '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
        'Dim LastFullBackup As DateTime = DateTime.Parse("12-31-2009")
        'Dim AsOfDate As DateTime = DateTime.Parse("01-01-2010")
        'Dim actual As Boolean = Business.IsFullBackupDue(LastFullBackup, AsOfDate, "Weekly")
        Assert.Inconclusive("A method that does not return a value cannot be verified.")
    End Sub

    '''<summary>
    '''A test for IsFullBackupDue for the Daily value
    '''</summary>
    <TestMethod()> _
    Public Sub IsFullBackupDueTest_Daily()
        'Possible Values:   Always, Never, Monthly, Daily, Weekly, Daily, Hourly, 
        '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
        'Dim LastFullBackup As DateTime = DateTime.Parse("12-31-2009")
        'Dim AsOfDate As DateTime = DateTime.Parse("01-01-2010")
        'Dim actual As Boolean = Business.IsFullBackupDue(LastFullBackup, AsOfDate, "Daily")
        Assert.Inconclusive("A method that does not return a value cannot be verified.")
    End Sub

    '''<summary>
    '''A test for IsFullBackupDue for the Hourly value
    '''</summary>
    <TestMethod()> _
    Public Sub IsFullBackupDueTest_Hourly()
        'Possible Values:   Always, Never, Monthly, Hourly, Weekly, Daily, Hourly, 
        '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
        'Dim LastFullBackup As DateTime = DateTime.Parse("12-31-2009")
        'Dim AsOfDate As DateTime = DateTime.Parse("01-01-2010")
        'Dim actual As Boolean = Business.IsFullBackupDue(LastFullBackup, AsOfDate, "Hourly")
        Assert.Inconclusive("A method that does not return a value cannot be verified.")
    End Sub


    '''<summary>
    '''A test for IsFullBackupDue for the Sunday value
    '''</summary>
    <TestMethod()> _
    Public Sub IsFullBackupDueTest_Sunday()
        'Possible Values:   Always, Never, Monthly, Sunday, Weekly, Daily, Hourly, 
        '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
        'Dim LastFullBackup As DateTime = DateTime.Parse("12-31-2009")
        'Dim AsOfDate As DateTime = DateTime.Parse("01-01-2010")
        'Dim actual As Boolean = Business.IsFullBackupDue(LastFullBackup, AsOfDate, "Sunday")
        Assert.Inconclusive("A method that does not return a value cannot be verified.")
    End Sub

    '''<summary>
    '''A test for IsFullBackupDue for the Monday value
    '''</summary>
    <TestMethod()> _
    Public Sub IsFullBackupDueTest_Monday()
        'Possible Values:   Always, Never, Monthly, Monday, Weekly, Daily, Hourly, 
        '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
        'Dim LastFullBackup As DateTime = DateTime.Parse("12-31-2009")
        'Dim AsOfDate As DateTime = DateTime.Parse("01-01-2010")
        'Dim actual As Boolean = Business.IsFullBackupDue(LastFullBackup, AsOfDate, "Monday")
        Assert.Inconclusive("A method that does not return a value cannot be verified.")
    End Sub

    '''<summary>
    '''A test for IsFullBackupDue for the Tuesday value
    '''</summary>
    <TestMethod()> _
    Public Sub IsFullBackupDueTest_Tuesday()
        'Possible Values:   Always, Never, Monthly, Tuesday, Weekly, Daily, Hourly, 
        '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
        'Dim LastFullBackup As DateTime = DateTime.Parse("12-31-2009")
        'Dim AsOfDate As DateTime = DateTime.Parse("01-01-2010")
        'Dim actual As Boolean = Business.IsFullBackupDue(LastFullBackup, AsOfDate, "Tuesday")
        Assert.Inconclusive("A method that does not return a value cannot be verified.")
    End Sub

    '''<summary>
    '''A test for IsFullBackupDue for the Wednesday value
    '''</summary>
    <TestMethod()> _
    Public Sub IsFullBackupDueTest_Wednesday()
        'Possible Values:   Always, Never, Monthly, Wednesday, Weekly, Daily, Hourly, 
        '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
        'Dim LastFullBackup As DateTime = DateTime.Parse("12-31-2009")
        'Dim AsOfDate As DateTime = DateTime.Parse("01-01-2010")
        'Dim actual As Boolean = Business.IsFullBackupDue(LastFullBackup, AsOfDate, "Wednesday")
        Assert.Inconclusive("A method that does not return a value cannot be verified.")
    End Sub

    '''<summary>
    '''A test for IsFullBackupDue for the Thursday value
    '''</summary>
    <TestMethod()> _
    Public Sub IsFullBackupDueTest_Thursday()
        'Possible Values:   Always, Never, Monthly, Thursday, Weekly, Daily, Hourly, 
        '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
        'Dim LastFullBackup As DateTime = DateTime.Parse("12-31-2009")
        'Dim AsOfDate As DateTime = DateTime.Parse("01-01-2010")
        'Dim actual As Boolean = Business.IsFullBackupDue(LastFullBackup, AsOfDate, "Thursday")
        Assert.Inconclusive("A method that does not return a value cannot be verified.")
    End Sub

    '''<summary>
    '''A test for IsFullBackupDue for the Friday value
    '''</summary>
    <TestMethod()> _
    Public Sub IsFullBackupDueTest_Friday()
        'Possible Values:   Always, Never, Monthly, Friday, Weekly, Daily, Hourly, 
        '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
        'Dim LastFullBackup As DateTime = DateTime.Parse("12-31-2009")
        'Dim AsOfDate As DateTime = DateTime.Parse("01-01-2010")
        'Dim actual As Boolean = Business.IsFullBackupDue(LastFullBackup, AsOfDate, "Friday")
        Assert.Inconclusive("A method that does not return a value cannot be verified.")
    End Sub

    '''<summary>
    '''A test for IsFullBackupDue for the Saturday value
    '''</summary>
    <TestMethod()> _
    Public Sub IsFullBackupDueTest_Saturday()
        'Possible Values:   Always, Never, Monthly, Saturday, Weekly, Daily, Hourly, 
        '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
        'Dim LastFullBackup As DateTime = DateTime.Parse("12-31-2009")
        'Dim AsOfDate As DateTime = DateTime.Parse("01-01-2010")
        'Dim actual As Boolean = Business.IsFullBackupDue(LastFullBackup, AsOfDate, "Saturday")
        Assert.Inconclusive("A method that does not return a value cannot be verified.")
    End Sub

    '''<summary>
    '''A test for ParseSettingFolder
    '''</summary>
    <TestMethod()> _
    Public Sub ParseSettingFolderTest()
        'Dim SettingFolder As String = String.Empty ' TODO: Initialize to an appropriate value
        'Dim expected As String = String.Empty ' TODO: Initialize to an appropriate value
        'Dim actual As String
        'actual = Business.ParseSettingFolder(SettingFolder)
        'Assert.AreEqual(expected, actual)
        Assert.Inconclusive("Verify the correctness of this test method.")
    End Sub

    '''<summary>
    '''A test for PutLastFullBackupDate
    '''</summary>
    <TestMethod()> _
    Public Sub PutLastFullBackupDateTest()
        'Dim BackupFolder As String = String.Empty ' TODO: Initialize to an appropriate value
        'Dim LastFullBackup As DateTime = New DateTime() ' TODO: Initialize to an appropriate value
        'Business.PutLastFullBackupDate(BackupFolder, LastFullBackup)
        Assert.Inconclusive("A method that does not return a value cannot be verified.")
    End Sub

    '''<summary>
    '''A test for WriteToLog
    '''</summary>
    <TestMethod()> _
    Public Sub WriteToLogTest()
        Dim message As String = String.Empty ' TODO: Initialize to an appropriate value
        Business.WriteToLog(message)
        Assert.Inconclusive("A method that does not return a value cannot be verified.")
    End Sub
End Class
